#include <stdio.h>
#include <stdlib.h>
#include <string.h>
typedef struct score *PSCORE;
typedef struct score {
	char name[20];
	int kor;
	int eng;
	int math;
	int sum;
	float average;
	PSCORE link;
} SCORE;

PSCORE createNode(SCORE a);
void readData(char *fname, PSCORE *head);
void writeData(char *fname, PSCORE *head);
void calculateAverage(PSCORE *head);
void RemoveAllList(PSCORE ptr);

int main()
{
	PSCORE stdPt = NULL;

	readData("data.txt", &stdPt);
	calculateAverage(&stdPt);
	writeData("result.txt", &stdPt);
	RemoveAllList(stdPt); /* ޸  */
	return 0;
}

void RemoveAllList(PSCORE ptrHead)
{
	PSCORE ptr;
	for (ptr = ptrHead; ptrHead != NULL; ptr = ptrHead)
	{
		ptrHead = ptrHead->link;
		if (ptr != NULL)
			free(ptr);
	}
}

void readData(char *fname, PSCORE *head)
{
	/* int n = 0; */
	SCORE st;
	PSCORE ptr;
	FILE *fp;
/*	if ((fp = fopen(fname, "r")) == NULL) */
	fopen_s(&fp, fname, "r");
	if(fp == NULL)
	{
		printf("Է    ϴ.\n");
		exit(1);
	}
/*	while (fscanf(fp, "%s %d %d %d", st.name, &st.kor, &st.eng, &st.math)
			!= EOF) */
	while (fscanf_s(fp, "%s %d %d %d", st.name, sizeof(st.name), &st.kor, &st.eng, &st.math)
			!= EOF)

	{
		ptr = createNode(st);
		if (*head == NULL)
			*head = ptr;
		else
		{
			ptr->link = *head;
			*head = ptr;
		}
		/* n++; ڵ  */
	}
	fclose(fp);
}

void writeData(char *fname, PSCORE *head)
{
	FILE *fp;
	int i;
	PSCORE ptr;

/*	if ((fp = fopen(fname, "w")) == NULL) */
	fopen_s(&fp, fname, "w");
	if(fp == NULL)
	{
		printf("    ϴ.\n");
		exit(1);
	}
	fprintf(fp, "# :  name    kor  eng math sum  avg\n");
	fprintf(fp, "------------------------------------------\n");
	for (ptr = *head, i = 0; ptr; ptr = ptr->link, i++)
	{
		fprintf(fp, "%d : %6s %4d %4d %4d %4d %10.6f\n", i, ptr->name,
			ptr->kor, ptr->eng, ptr->math, ptr->sum, ptr->average);
	}
}

void calculateAverage(PSCORE *head)
{
	PSCORE ptr;

	for (ptr = *head; ptr; ptr = ptr->link)
	{
		ptr->sum = ptr->kor + ptr->eng + ptr->math;
		ptr->average = ptr->sum / 3.0f;
	}
}

PSCORE createNode(SCORE a)
{
	PSCORE ptr;
	ptr = (PSCORE) malloc(sizeof(SCORE));
/*	strcpy(ptr->name, a.name); */
	strcpy_s(ptr->name, sizeof(ptr->name), a.name);

	ptr->kor = a.kor;
	ptr->eng = a.eng;
	ptr->math = a.math;
	ptr->link = NULL;
	return ptr;
}
